SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Test'!

Object subclass: #SVNDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNDummy methodsFor: 'as yet unclassified' stamp: 'rkrk 1/6/2008 21:23'!
m1

	^ 1! !

Object subclass: #SVNMethod
	instanceVariableNames: 'methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 21:38'!
methodReference: aMethodReference 
	
	^ self new
		methodReference: aMethodReference;
		yourself! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 22:07'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodClass = otherMethod methodClass &
			(self methodReference = otherMethod methodReference).! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodClass
	
	^ self methodReference actualClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodReference
	
	 ^ methodReference! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:39'!
methodReference: aMethodReference 
	
	methodReference := aMethodReference! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:42'!
selector
	
	^ self methodReference methodSymbol! !

Object subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
addClass: aClass

	self versionedClasses add: aClass! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:36'!
addMethod: aMethod 
	
	| svnMethod |
	svnMethod := SVNMethod methodReference: aMethod methodReference.
	^ self versionedMethods add: svnMethod! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:53'!
versionedMethods
	
	| methodsOfClasses |
	self versionedClasses isEmpty ifTrue: [^ versionedMethods].
	
	methodsOfClasses := self versionedClasses gather: [:eachClass |
		eachClass methodDict collect: [:eachMethod |
			SVNMethod methodReference: eachMethod methodReference]].
	^ versionedMethods union: methodsOfClasses! !

Object subclass: #SVNWorkingCopyAccessor
	instanceVariableNames: 'workingCopyPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNWorkingCopyAccessor class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 23:08'!
workingCopyPath: aString 

	^ self new
		workingCopyPath: aString;
		yourself! !

!SVNWorkingCopyAccessor methodsFor: 'accessing' stamp: 'rkrk 1/7/2008 02:42'!
primSvnAdd: target

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNWorkingCopyAccessor methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 23:10'!
workingCopyPath

	^ workingCopyPath ! !

!SVNWorkingCopyAccessor methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 23:09'!
workingCopyPath: aString

	workingCopyPath := aString! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:09'!
answer17

	<primitive: 'answerSeventeen' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:58'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

TestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNMethodTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/6/2008 22:00'!
testEquals

	| methodBlock method1 method2 |

	methodBlock := [SVNMethod methodReference: (SVNDummy>>#m1) methodReference].
	method1 := methodBlock value.
	method2 := methodBlock value.

	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

TestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNProjectTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/6/2008 22:08'!
testAddClass

	| sut aClass methodsOfClass expected result |
	sut := SVNProject new.
	aClass := SVNDummy.
	sut addClass: aClass.
	
	self assert: (sut versionedClasses includes: aClass).
	
	methodsOfClass := aClass methodDict collect: [:ea |
		SVNMethod methodReference: ea methodReference].
	expected := methodsOfClass asSet.
	result := sut versionedMethods.
	self assert: result = expected.! !

!SVNProjectTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/6/2008 21:46'!
testAddMethod
	
	| sut aMethod svnMethod |
	sut := SVNProject new.
	aMethod := SVNDummy >> #m1.
	sut addMethod: aMethod.
	
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	
	self assert: svnMethod methodClass = aMethod methodClass.
	self assert: svnMethod selector = aMethod selector! !

TestCase subclass: #SVNWorkingCopyAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 02:56'!
assertFile: fileName IsAddedToWC: workingCopyPath

	| svnDir wcEntries |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	self assert: (wcEntries contents includesSubString: fileName).! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 02:19'!
createFileNamed: fileName in: aPath

	| dir |
	dir := FileDirectory on: aPath.
	(dir newFileNamed: fileName) close.! !

!SVNWorkingCopyAccessorTest methodsFor: 'helper' stamp: 'rkrk 1/7/2008 02:06'!
createRepositoryIn: aPath

	| slash |
	slash := FileDirectory slash.
	
	self assert: (FileDirectory isLegalFileName: aPath).
	self deny: (FileDirectory on: aPath , slash) exists.
	
	"process := ExternalOSProcess exec: 'svnadmin create ' , aPath.
	[process isComplete] whileFalse: [(Delay forMilliseconds: 50) wait]." "geht nicht!! mist!!"
	OSProcess command: 'svnadmin create ' , aPath.
	
	[(FileDirectory on: aPath , slash) exists]
		whileFalse: [(Delay forMilliseconds: 20) wait].! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 02:08'!
createRepositoryIn: repositoryPath andCreateWorkingCopyIn: workingCopyPath thenDo: aBlock 

	| repositoryDir workingCopyDir |
	self createRepositoryIn: repositoryPath.
	self 
		createWorkingCopyOfRepository: repositoryPath
		in: workingCopyPath.

	[aBlock value] ensure: [
		repositoryDir := FileDirectory on: repositoryPath.
		repositoryDir exists ifTrue: [repositoryDir recursiveDelete].
		
		workingCopyDir := FileDirectory on: workingCopyPath.
		workingCopyDir exists ifTrue: [workingCopyDir recursiveDelete]]! !

!SVNWorkingCopyAccessorTest methodsFor: 'helper' stamp: 'rkrk 1/7/2008 02:03'!
createWorkingCopyOfRepository: repositoryPath in: workingCopyPath

	| slash  repositoryURLPath process |
	slash := FileDirectory slash.
	
	self assert: (FileDirectory on: repositoryPath , slash) exists.
	self deny: (FileDirectory on: workingCopyPath) exists.
	
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.

	process := [OSProcess command: 'svn co ' , repositoryURLPath , ' ' , workingCopyPath] fork.
	
	[process isTerminated and: [(FileDirectory on: workingCopyPath) exists]]
		whileFalse: ["(Delay forMilliseconds: 20) wait"].! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 01:20'!
pathForTests
	^ SmalltalkImage current imagePath , FileDirectory slash , 'svnTests'! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 01:27'!
setUp

	super setUp.
	(FileDirectory on: self pathForTests) assureExistence.! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 01:26'!
tearDown

	super tearDown.
	(FileDirectory on: self pathForTests) recursiveDelete.! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/6/2008 23:52'!
testCreationForPath

	| path sut |
	path := '/Users/robertkrahn/studium/squeakSVN/spass/testRepositoryClient'.
	sut := SVNWorkingCopyAccessor workingCopyPath: path.
	self assert: sut workingCopyPath = path! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/6/2008 23:07'!
testReadFileNames

"	| path sut expectedFiles expectedDirs |
	path := '/Users/robertkrahn/studium/squeakSVN/spass/testRepositoryClient'.
	sut := SVNWorkingCopyAccessor rootPath: path.
	
	expectedFiles := Set with: 'textFile'.
	self assert: sut fileNames = expectedFiles.
	
	expectedDirs := Set with: 'directory'.
	self assert: sut dirNames = expectedDirs."! !

!SVNWorkingCopyAccessorTest methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 02:59'!
testSVNAdd
	| slash repositoryPath workingCopyPath fileName filePath sut |
	slash := FileDirectory slash.
	repositoryPath := self pathForTests , slash , 'repository'.
	workingCopyPath := self pathForTests , slash , 'workingCopy'.
	self 
		createRepositoryIn: repositoryPath
		andCreateWorkingCopyIn: workingCopyPath
		thenDo: 
			["Create a normal file and add it to a working copy. Test if the file was added"
			fileName := 'testFile'.
			self createFileNamed: fileName in: workingCopyPath.
			filePath := workingCopyPath , slash , fileName.

			sut := SVNWorkingCopyAccessor workingCopyPath: workingCopyPath.
			sut primSvnAdd: filePath.
			
			self assertFile: fileName IsAddedToWC: workingCopyPath]! !
